<template>
  <div v-loading="isLoading" class="object-fill referral-diagram">
    <div class="w-full min-h-[20vh] mt-6">
      <el-scrollbar>
        <el-tree
          :data="treeData"
          :props="props"
          :height="208"
          label
          @node-expand="expandNode"
          @node-collapse="collapeNode"
        >
          <template #default="{ data }">
            <div
              class="flex flex-col h-fit rounded-lg border-[3px] border-[var(--border)] bg-[rgba(0, 0, 0, 0.1)]"
            >
              <div class="flex justify-between items-center py-2 px-4 border-b">
                <div class="flex items-center">
                  <span v-if="mediaScreen > 639" class="mr-2">
                    <img
                      :src="getAssetImage('assets/theme/green_peru/icons/thumb_up.png')"
                      v-if="data.Layer === 0"
                    />
                    <img
                      :src="getAssetImage('assets/theme/green_peru/icons/account.png')"
                      v-else="data.Layer === 0"
                    />
                  </span>
                  <span class="text-sm font-bold txt"
                    >{{ data.Username }} / {{ data.Currency }}</span
                  >
                </div>
                <div class="text-sm flex items-center txt">
                  +{{ data.ChildCount }}
                  <div class="flex justify-center items-center ml-2 text-sm text-[var(--text)]">
                    <font-awesome-icon
                      v-if="!data.IsExpand && data.ChildCount >= 0"
                      icon="circle-plus"
                    />
                    <font-awesome-icon v-else icon="circle-minus" />
                  </div>
                </div>
              </div>
              <div class="flex flex-col item-content font-normal">
                <div class="text-xs mobile-net-turnover txt">
                  Turnover
                  <span :class="data.TurnoverMarginColor"
                    >{{ data.TurnoverMarginPercentage }} %</span
                  >
                </div>
                <div class="flex justify-between">
                  <div class="text-xs txt">
                    This / Last Month
                    <span class="desktop-net-turnover">Turnover</span> :
                  </div>
                  <div class="flex">
                    <span class="text-sm mr-3 txt font-medium"
                      >{{ data.ThisMonthTurnoverForDisplay }} /
                      {{ data.LastMonthTurnoverForDisplay }}</span
                    >
                    <span
                      :class="[
                        data.TurnoverMarginColor,
                        'desktop-net-turnover text-sm',
                      ]"
                      >{{ data.TurnoverMarginPercentage }} %</span
                    >
                  </div>
                </div>
                <div class="text-xs mobile-net-turnover txt">
                  Net Turnover
                  <span :class="data.NetTurnoverMarginColor"
                    >{{ data.NetTurnoverMarginPercentage }} %</span
                  >
                </div>
                <div class="flex justify-between">
                  <div class="text-xs txt">
                    This / Last Month
                    <span class="text-xs desktop-net-turnover txt">Net Turnover</span> :
                  </div>
                  <div class="flex">
                    <span class="text-sm mr-3 txt font-medium"
                      >{{ data.ThisMonthNetTurnoverForDisplay }} /
                      {{ data.LastMonthNetTurnoverForDisplay }}</span
                    >
                    <span
                      :class="[
                        data.NetTurnoverMarginColor,
                        'desktop-net-turnover text-sm',
                      ]"
                      >{{ data.NetTurnoverMarginPercentage }} %</span
                    >
                  </div>
                </div>
              </div>
            </div>
          </template>
        </el-tree>
      </el-scrollbar>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { ITreeNode } from "@/models/referral/getReferral";

export default defineComponent({
  components: {},
  setup() {
    const { treeData, isLoading } = useReferralDiagram();
    const { getAssetImage } = commonHelper;
    const props = {
      value: "CustomerId",
      label: "Currency",
      username: "Username",
      children: "Children",
    };
    const expandNode = (node: ITreeNode) => {
      node.IsExpand = true;
    };
    const collapeNode = (node: ITreeNode) => {
      node.IsExpand = false;
    };
    const mediaScreen = window.innerWidth;
    return {
      treeData,
      isLoading,
      props,
      expandNode,
      collapeNode,
      getAssetImage,
      mediaScreen,
    };
  },
});
</script>
<style lang="scss" scoped>
.txt {
  color: var(--text5);
}
:deep(.el-tree .el-tree-node__content) {
  margin-top: 8px;
}
:deep(.el-tree) {
  background: none;
  height: calc(100dvh - 92px);
  overflow: auto;
  @media screen and (min-width: 641px) {
    .el-tree-node__content {
      height: 120px;
      > div {
        width: 420px;
        .item-content {
          padding: 1.2rem 1rem;
        }
      }
    }
  }
  @media screen and (max-width: 640px) {
    .el-tree-node__content {
      font-size: 14px;
      height: 150px;
      > div {
        width: 328px;
        .item-content {
          padding: 0.5rem 1rem;
        }
      }
    }
    .el-tree-node {
      width: min-content;
      margin: 0 auto;
    }
  }
  .el-tree-node__children {
    .el-tree-node__content::before {
      content: "" !important;
      height: 3000000px !important;
      width: 10px !important;
      border-left: 3px solid var(--border) !important;
      border-bottom: 3px solid var(--border) !important;
      border-radius: 0 0 0 7px !important;
      margin-bottom: 3000000px !important;
    }
    @media screen and (max-width: 640px) {
      .el-tree-node__content {
        padding-left: 7px !important;
        > div {
          width: 312px;
        }
      }
    }
  }
  .el-tree-node__content {
    width: fit-content;
    position: relative;
  }
  .el-tree-node__content:hover {
    background: none;
  }
  .el-icon {
    display: none;
  }
}
@media screen and (min-width: 641px) {
  .mobile-net-turnover {
    display: none;
  }
}
@media screen and (max-width: 640px) {
  .desktop-net-turnover {
    display: none;
  }
}
</style>
